<?php
include("header.php");

test_is_connected();

function import_nzb_file($filename, $collection_name)
{
    $nzb = simplexml_load_file($filename);
    if ($nzb == FALSE) {
        return FALSE;
    }

    foreach ($nzb->{'file'} as $file) {
        $subject = trim($file['subject']);
        $poster = trim($file['poster']);
        $timestamp = intval(trim($file['date']));
        $file_size = 0;

        foreach($file->segments->segment as $part) {
            $parts[] = array("message_id" => '<'.trim($part).'>',
                             "partnum" => intval(trim($part['number'])),
                             "size" => intval(trim($part['bytes']))
                            );
            $file_size = $file_size + intval(trim($part['bytes']));
        }

        foreach($file->groups->group as $group) {
            $groups[] = trim($group);
        }

        if (is_string($collection_name) &&
            is_string($subject) &&
            is_string($poster) &&
            is_int($timestamp) &&
            is_int($file_size) &&
            is_array($groups) &&
            is_array($parts)) {
                nntpgrab_schedular_add_task_to_queue($collection_name,
                                                     $subject,
                                                     $poster,
                                                     $timestamp,
                                                     $file_size,
                                                     $groups,
                                                     $parts);
        } else {
            die("One or more variables are not what they should be. Meaning int, array or string.");
        }

        unset($parts, $groups); // Unset arrays
    }

    nntpgrab_schedular_save_queue();

    return TRUE;
}

if (isset($_FILES['nzbfile'])) {
    if (!import_nzb_file($_FILES['nzbfile']['tmp_name'], substr_replace(($_FILES['nzbfile']['name']), '', -4))) {
        echo "Import of NZB file failed";
    } else {
        echo "Import of NZB file succeeded";
    }
}

?>

<div class="EntryBlock">
    <form method="post" enctype="multipart/form-data">
    <fieldset class="EntryFieldSet">
      <legend>Quick Import</legend>
      <input type="file" name="nzbfile">
      <input type="submit" value="Add">
    </fieldset>
    </form>
</div>

<?php include("footer.php"); ?>

