<?php
include("magic.php");


function process_stats_add(array $resarray,$echoon=true)
{
    if (!isset($resarray['history']) || count($resarray['history']) < 2)
    {
        return false; #Something is wrong, I am not here to compensate for problems... you figure it out!
    }

    $tfile = "dlstats.txt";
    if (file_exists($tfile))
    {
        $prevrestmp = file($tfile);
    }
    else
    {
        $prevrestmp = array();
    }
    if ($resarray['timestamp'] == 0)
    {
        if (file_exists($tfile))
        {
            if ($echoon)
            {
                echo file_get_contents($tfile);
            }
        }
        return false; # No results present...
    }
    # Read back previous results and store 'em
    $prevres = array();
    foreach($prevrestmp as $linenum => $val)
    {
        if (strlen($val) > 1)
        {
            list($timestamp,$dlspeed) = explode(':',trim($val));
            $prevres[$timestamp] = $dlspeed;
        }
    }
    # Small cleanup
    unset($prevrestmp);

        for ($i = 0; $i < 10; $i++) {
            $stamp = $resarray['timestamp'] - 9 + $i;
            $prevres[$stamp] = $resarray['history'][$i];
        }

    ksort($prevres); # Order by timestamp
    while(count($prevres) > 7200)
    {
        # Max number of data is 2 hours...
        array_pop($prevres);
    }
    # Newest records should be on top, so:
    $prevres = array_reverse($prevres,true);
    # Unknown how this cannot be true, but hey, better safe than sorry
    if (count($prevres) > 0)
    {
        $constructed = construct_dlstats_file($prevres);
        if (strlen($constructed) > 10)
            file_put_contents($tfile,$constructed);
        if ($echoon)
            echo $constructed;
    }
}
function construct_dlstats_file(array $prevres)
{
    $res = "";
    while($key = key($prevres))
    {
        $res.=$key.":".($prevres[$key]);
        unset($prevres[$key]);
        
        if (count($prevres)>0)
            $res.="\n";
        
    }
    return $res;
}

$resarray = nntpgrab_connections_get_speed_history();
process_stats_add($resarray,false);
//var_dump($resarray);
// Enable for test data:
//$resarray = array('history' => array ("1" => 10,"2" => 12, "4" => 435), 'timestamp'=> time());

?>
